package mailbeans;

import java.io.*;
import java.util.*;
import java.awt.*;
import java.awt.event.*;
/**
 * This type was created in VisualAge.
 */
public abstract class MailBox extends MailBeansContainer implements MessageListener, SerializeDataListener {
	public String path = "";
	private Vector messages = new Vector();
	private int filecount = 1000000;
	private boolean store = false;
/**
 * Folders constructor comment.
 */
public MailBox() {
	super();
	init();
}
/**
 * This method was created in VisualAge.
 * @param msg MailBean.Message
 */
public void addMessage(Message msg) {
	//String id = msg.getMessageID();
	int i=0;
	messages.addElement(msg);
	String from ="";
	StringTokenizer st = new StringTokenizer(msg.getFrom(), "<>");
	while (st.hasMoreTokens()) {
		from=st.nextToken();
	}
}
/**
 * This method was created in VisualAge.
 * @param pos int
 */
public void deleteMessage(int index) {
	String filename = ((Message)messages.elementAt(index)).getFilename();
	File f = new File(filename);
	f.delete();
	messages.removeElementAt(index);
}
/**
 * This method was created in VisualAge.
 */
public void fireHandleMessage(Message msg) {
	MessageEvent me = new MessageEvent(this, msg);
	for (int i=0; i<messageListener.size(); i++) {
		MessageListener ml = (MessageListener) messageListener.elementAt(i);
		ml.handleMessage(me);
	}
}
/**
 * This method was created in VisualAge.
 */
public void fireShowMessage(Message msg) {
	MessageEvent me = new MessageEvent(this, msg);
	for (int i=0; i<messageListener.size(); i++) {
		MessageListener ml = (MessageListener) messageListener.elementAt(i);
		ml.showMessage(me);
	}
}
/**
 * This method was created in VisualAge.
 * @return mailbeans.Message
 * @param inx int
 */
public Message getMessage(int index) {
	return (Message)messages.elementAt(index);
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public String getPath() {
	return path;
}
/**
 * This method was created in VisualAge.
 * @param e MailBean.MessageEvent
 */
public void handleMessage(MessageEvent e) {
	if (e!=null) {
		Message msg = e.getMessage();
		String id = msg.getMessageID();
		int i=0; // Checking if this message is a new message, or if it is already downloaded
		while ((i<messages.size()) && (id.compareTo(((Message)messages.elementAt(i)).getMessageID()))!=0){
			i++;
		}
		if (!(i<messages.size())) {
			//System.out.println(msg.getMessageID());
			storeMessage(msg);
			addMessage(msg);
		}
	}
}
/**
 * This method was created in VisualAge.
 */
protected void init() {
	/*list = new java.awt.List();
	setLayout(new BorderLayout());
	add("Center", list);
	list.addActionListener(this);
	addMessageListener(this);*/
}
/**
 * This method was created in VisualAge.
 */
private void loadMessages() {
	output("searching for stored messages");
	File f = new File(path);
	//System.out.println(path);
	String str[] = f.list();
	if (str!=null && str.length!=0) {
		for (int i=0; i<str.length; i++) {
			if ((str[i].toLowerCase()).endsWith(".msg")) {
				Message msg = new Message();
				//System.out.println(str[i]);
				msg.setFilename(path+str[i]);
				msg.load();
				output("loading Message "+(i+1)+" of "+str.length);				
				addMessage(msg);
				msg.freeMem();
			} else
			if ((str[i].toLowerCase()).endsWith(".mmsg")) {
				MimeMessage mmsg = new MimeMessage();
				//System.out.println(str[i]);
				mmsg.setFilename(path+str[i]);
				mmsg.load();
				output("loading MimeMessage "+(i+1)+" of "+str.length);				
				addMessage(mmsg);
				mmsg.freeMem();
			}
		}
	} else {
		output("no stored message found");
	}
}
/**
 * This method was created in VisualAge.
 */
public void output(String text) {
	OutputEvent e = new OutputEvent(this, text);
	for (int i=0; i<outputListener.size(); i++) {
		OutputListener ml = (OutputListener) outputListener.elementAt(i);
		ml.handleOutput(e);
	}
}
/**
 * This method was created in VisualAge.
 * @param s java.io.ObjectInputStream
 * @exception java.io.IOException The exception description.
 */
public void readData(SerializeDataEvent e) {
	ObjectInputStream in = e.getObjectInputStream();
	store = true;
	try {
		filecount = in.readInt();
		loadMessages();
	} catch (IOException ex) {
		System.out.println("IOException in mailbeans.MessageViewer.readProperties(): "+ex.getMessage());
	}
}
/**
 * This method was created in VisualAge.
 * @param path java.lang.String
 */
public void setPath(String path) {
	StringTokenizer st = new StringTokenizer(path, "\\/");
	StringBuffer sb = new StringBuffer();
	while (st.hasMoreTokens()) {
		sb.append(st.nextToken());
		sb.append(File.separatorChar);
	}
	this.path = sb.toString();
}
/**
 * This method was created in VisualAge.
 * @param e MailBean.MessageEvent
 */
public void showMessage(MessageEvent e) {
}
/**
 * This method was created in VisualAge.
 */
private void storeMessage(Message msg) {
	if (store) {
		String filename = msg.getFilename();
		if (filename=="") {
			filename = path+filecount+".msg";
			if (msg instanceof MimeMessage) filename = path+filecount+".mmsg";
		} 
		//System.out.println("Filename: "+msg.getFilename()+"/"+filename);
		msg.setFilename(filename);
		msg.store();
		filecount++;
		msg.freeMem();
	}
}
/**
 * This method was created in VisualAge.
 * @param s java.io.ObjectOutputStream
 * @exception java.io.IOException The exception description.
 */
public void writeData(SerializeDataEvent e) {
	ObjectOutputStream out = e.getObjectOutputStream();
	try {
		out.writeInt(filecount);
	} catch (IOException ex) {
		System.out.println("IOExcepion in mailbeans.MessageViewer.writeProperties(): "+ex.getMessage());
	}
	
}
}