package mailbeans;

import java.io.*;
import java.util.*;

/**
 * This type was created in VisualAge.
 */
public class Message implements Serializable {
	String[] msg;
	String date;
	String from;
	String subject;
	String returnPath;
	String to;
	String messageID;
	String msgBody;
	String filename;
	int msgBodyStartsAt=0;
/**
 * Message constructor comment.
 */
public Message() {
	init();
}
/**
 * This method was created in VisualAge.
 * @param msg java.lang.String[]
 */
public Message(String[] msg) {
	this.msg = msg;
	init();
}
/**
 * This method was created in VisualAge.
 */
public void create() {
	Vector v = new Vector();
	String [] s = getHeader();
	for (int i=0; i<s.length; i++) {
		v.addElement(s[i]);
	}
	v.addElement("");
	v.addElement(msgBody);
	
	msg = new String[v.size()];
	for (int i=0; i<msg.length; i++) {
		msg[i] = (String)v.elementAt(i);
	}
}
/**
 * This method was created in VisualAge.
 * @return 
 * @param filename java.lang.String
 */
public void export(String filename) {
	if (filename!=null) {
		try {
			FileOutputStream fos = new FileOutputStream(filename);
			for(int i=0; i<msg.length; i++) {
				fos.write(msg[i].getBytes());
				fos.write(13);
				fos.write(10);
			}
			fos.close();
		} catch (IOException e) {
			System.out.println("IOException in mailbeans.Message.store(): "+e.getMessage());
		}
	}
}
/**
 * This method was created in VisualAge.
 */
public void freeMem() {
	msg = null;
}
/**
 * This method was created in VisualAge.
 * @return java.awt.Component
 */
public java.awt.Component getComponent() {
	java.awt.TextArea ta = new java.awt.TextArea();
	ta.setText(getMsgBodyString());
	return ta;
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public String getDate() {
	if (msg==null) {
		if (date=="") {
			// create a new Date
			StringBuffer sb = new StringBuffer();
			Calendar calendar = new GregorianCalendar();
			Date trialTime = new Date();
			calendar.setTime(trialTime);
			switch (calendar.get(Calendar.DAY_OF_WEEK)) {
				case 0: sb.append("Mon, "); break;
				case 1: sb.append("Tue, "); break;
				case 2: sb.append("Wed, "); break;
				case 3: sb.append("Thu, "); break;
				case 4: sb.append("Fri, "); break;
				case 5: sb.append("Sat, "); break;
				case 6: sb.append("Sun, "); break;
			}
			sb.append(calendar.get(Calendar.DATE));
			switch (calendar.get(Calendar.MONTH)) {
				case 0: sb.append(" Jan "); break;
				case 1: sb.append(" Feb "); break;
				case 2: sb.append(" Mar "); break;
				case 3: sb.append(" Apr "); break;
				case 4: sb.append(" May "); break;
				case 5: sb.append(" Jun "); break;
				case 6: sb.append(" Jul "); break;
  				case 7: sb.append(" Aug "); break;
 		 		case 8: sb.append(" Sep "); break;
  				case 9: sb.append(" Oct "); break;
		  		case 10: sb.append(" Nov "); break;
		  		case 11: sb.append(" Dec "); break;
			}
			sb.append(calendar.get(Calendar.YEAR));
			sb.append(" "+calendar.get(Calendar.HOUR_OF_DAY));
			sb.append(":"+calendar.get(Calendar.MINUTE));
			sb.append(":"+calendar.get(Calendar.SECOND));
			int zone = calendar.get(Calendar.ZONE_OFFSET)/(60*60*10);
			if (zone>0) sb.append(" +"); else sb.append(" -");
			if (zone<900 && zone>-900) sb.append("0");
			sb.append(zone);
			date=sb.toString();
		}
	}else {
		// Parse Date
		/*
		if (date=="") {
			int i=0;
			while (i<msg.length && !msg[i].startsWith("Date:")) i++;
			if (i<msg.length) date = msg[i].substring(5);
		}*/
	}
	return date;
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 * @param field java.lang.String
 */
public String getFieldText(String field) {
	String str = "";
	if (msg!=null) {
		int i = 0;
		while (i<msg.length && !(msg[i].toLowerCase().startsWith(field.toLowerCase()))) {
			i++;
			if (msg[i].length()==0) {
				// end if header
				return "";
			}
		}
		if (i<msg.length) {
			str = msg[i].substring(field.length());
			i++;
			while (i<msg.length && msg[i].length()>0 && ((msg[i].charAt(0)=='\t')||(msg[i].charAt(0)==' '))) {
				str = str +msg[i].substring(1);
				i++;
			}
		}
	} else {
		System.out.println("msg is null");
	}
	//System.out.println(str.trim());
	return str.trim();
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public String getFilename() {
	return filename;
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public String getFrom() {
	/*if (msg!=null && from=="") {
		int i=0;
		while (i<msg.length && !msg[i].startsWith("From:")) i++;
		if (i<msg.length) from = msg[i].substring(5);
	}*/
	return from;
	
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public String[] getHeader() {
	Vector v = new Vector();
	
	v.addElement("Return-Path: "+getFrom());
	v.addElement("From: "+getFrom());
	v.addElement("To: "+getTo());
	v.addElement("Date: "+getDate());
	v.addElement("Subject: "+getSubject());
	v.addElement("Message-ID: "+getMessageID());
	String[] s = new String[v.size()];
	for (int i=0; i<s.length; i++) {
		s[i] = (String)v.elementAt(i);
	}
	return s;
	/*
	StringBuffer sb = new StringBuffer();
	sb.append("From: "+getFrom()+"\n");
	sb.append("To: "+getTo()+"\n");
	sb.append("Date: "+getDate()+"\n");
	sb.append("Subject: "+getSubject()+"\n");
	return sb.toString();*/
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public String getMessageID() {
	/*if (msg!=null && messageID=="") {
		int i=0;
		while (i<msg.length && !msg[i].toLowerCase().startsWith("message-id:")) i++;
		if (i<msg.length) {
			messageID = msg[i].substring(11);
			int start=0;
			int end=messageID.length()-1;
			if (messageID.charAt(start)==' ') start++;
			if (messageID.charAt(start)=='<') start++;
			if (messageID.charAt(end)==' ') end--;
			if (messageID.charAt(end)=='>') end--;
			messageID = messageID.substring(start, end+1);
		}
	}*/
	if (messageID == "" && msg == null) {
		StringBuffer sb = new StringBuffer();
		Calendar calendar = new GregorianCalendar();
		Date trialTime = new Date();
		calendar.setTime(trialTime);
		sb.append(calendar.get(Calendar.YEAR));
		sb.append(calendar.get(Calendar.MONTH));
		sb.append(calendar.get(Calendar.DATE));
		sb.append(calendar.get(Calendar.HOUR_OF_DAY));
		sb.append(calendar.get(Calendar.MINUTE));
		sb.append(calendar.get(Calendar.SECOND));
		StringTokenizer st = new StringTokenizer(getFrom(), "@");
		String dom = "";
		while (st.hasMoreTokens()) {
			dom=st.nextToken();
		}
		sb.append("@"+dom);
		messageID=sb.toString();
	} else {
		int start=0;
		int end=messageID.length()-1;
		if (messageID.charAt(start)==' ') start++;
		if (messageID.charAt(start)=='<') start++;
		if (messageID.charAt(end)==' ') end--;
		if (messageID.charAt(end)=='>') end--;
		messageID = messageID.substring(start, end+1);
	}
	return messageID.trim();
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String[]
 */
public String[] getMsg() {
	if (msg==null) load();
	return msg;
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public String[] getMsgBody() {
	if (msg==null) {
		load();
	} else {
		String[] str=null;
		int i=0;
		while (i<msg.length && msg[i].length()!=0) i++;
		if (i<msg.length) {
			str = new String[msg.length-i];
			for (int j=0; j<str.length; j++) str[j] = msg[j+i];
		}
		return str;
	}
	return msg;
	/*
	StringBuffer sb = new StringBuffer();
	if (msg==null) {
		sb.append(msgBody+"\n");
	} else {
		int i=0;
		while (i<msg.length && msg[i].length()!=0) i++;
		while (i<msg.length && msg[i]!=".") {
			sb.append(msg[i++]+"\n");
		}
	}
	return sb.toString();*/
	
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public String getMsgBodyString() {
	if (msg==null) {
		if (filename!="") {
			load();
		} 
	}
	if (msg!=null) {
		StringBuffer sb = new StringBuffer();
		if (msg==null) {
			sb.append(msgBody+"\n");
		} else {
			int i=0;
			while (i<msg.length && msg[i].length()!=0) i++;
			while (i<msg.length && msg[i]!=".") {
				sb.append(msg[i++]+"\n");
			}
		}
		return sb.toString();
	}
	return null;
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public String getReturnPath() {
/*	if (returnPath=="") {
		int i=0;
		while (i<msg.length && !msg[i].startsWith("Return-Path:")) i++;
		if (i<msg.length) returnPath = msg[i].substring(12);
	}
	return returnPath.trim();*/
	return returnPath;
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public String getSubject() {
	/*if (msg!=null && subject=="") {
		int i=0;
		while (i<msg.length && !msg[i].startsWith("Subject:")) i++;
		if (i<msg.length) subject = msg[i].substring(8);
	}	
	return subject.trim();*/
	return subject;
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public String getTo() {
	/*int i=0;
	while (i<msg.length && msg[i].startsWith("To:")) i++;
	to = msg[i].substring(3);*/
	return to;
}
/**
 * This method was created in VisualAge.
 */
public void init() {
	date="";
	from="";
	subject="";
	returnPath="";
	to="";
	messageID="";
	filename = "";
	msgBody="";
	msgBodyStartsAt=0;
	if (msg!=null) {
		parse();
	} 
}
/**
 * This method was created in VisualAge.
 * @param filename java.lang.String
 */
public void load() {
	if (filename!="") {
		//System.out.println("Message load: "+filename);
		try {
			FileInputStream in = new FileInputStream(filename);
			ObjectInputStream s = new ObjectInputStream(in);
			//readObject(s);
			int length = s.readInt();
			msg = new String[length];
			for (int i=0; i<msg.length; i++) {
				msg[i] = (String)s.readObject();
			}
			s.close();
		} catch (IOException ex) {
			System.out.println("IOExeption in mailbeans.Message.load: "+ex.getMessage());
		} catch (ClassNotFoundException ex) {
			System.out.println("ClassNotFoundExeption in mailbeans.Message.load: "+ex.getMessage());
		}
	}
	parse();
}
/**
 * This method was created in VisualAge.
 */
public void parse() {
	date = getFieldText("Date:");
	from = getFieldText("From:");
	subject = getFieldText("Subject:");
	returnPath = getFieldText("Return-Path:");
	to = getFieldText("To:");
	messageID = getFieldText("Message-ID:");
}
/**
 * This method was created in VisualAge.
 * @param s java.io.ObjectInputStream
 * @exception java.io.IOException The exception description.
 */
private void readObject(ObjectInputStream s) throws IOException {
	int length;
	try {
		s.defaultReadObject();
		length=s.readInt();
		msg = new String[length];
		for(int i=0; i<length; i++) {
			msg[i]=(String)s.readObject();
		}
	} catch (ClassNotFoundException ex) {
		throw new IOException(ex.getMessage());
	}
}
/**
 * This method was created in VisualAge.
 * @param date java.lang.String
 */
public void setDate(String date) {
	this.date = date;
}
/**
 * This method was created in VisualAge.
 * @param s java.lang.String
 */
public void setFilename(String s) {
	filename = s;
}
/**
 * This method was created in VisualAge.
 * @param from java.lang.String
 */
public void setFrom(String from) {
	this.from = from;
}
/**
 * This method was created in VisualAge.
 * @param msgBody java.lang.String
 */
public void setMsgBody(String msgBody) {
	this.msgBody = msgBody;
}
/**
 * This method was created in VisualAge.
 * @param returnPath java.lang.String
 */
public void setReturnPath(String returnPath) {
	this.returnPath=returnPath;
}
/**
 * This method was created in VisualAge.
 * @param subject java.lang.String
 */
public void setSubject(String subject) {
	this.subject = subject;
}
/**
 * This method was created in VisualAge.
 * @param to java.lang.String
 */
public void setTo(String to) {
	this.to = to;
}
/**
 * This method was created in VisualAge.
 * @param filename java.lang.String
 */
public void store() {
	if (filename!="") {
		try {
			//System.out.println("Message store: "+filename);
			FileOutputStream out = new FileOutputStream(filename);
			ObjectOutputStream s = new ObjectOutputStream(out);
			// writing
			//s.defaultWriteObject();
			s.writeInt(msg.length);
			for (int i=0; i<msg.length; i++) {
				s.writeObject(msg[i]);
			}
			s.close();
		} catch (IOException ex) {
			System.out.println("IOExeption in mailbeans.Message.store: "+ex.getMessage());
		}
	}
}
/**
 * This method was created in VisualAge.
 * @param s java.io.ObjectOutputStream
 * @exception java.io.IOException The exception description.
 */
private void writeObject(ObjectOutputStream s) throws IOException {
	s.defaultWriteObject();
	s.writeInt(msg.length);
	for (int i=0; i<msg.length; i++) {
		s.writeObject(msg[i]);
	}
}
}