package mailbeans;

import java.awt.*;
import java.awt.event.*;
import java.util.*;
/**
 * This type was created in VisualAge.
 */
public class MessageComposer extends MailBeansComponent implements WindowListener, ActionListener, ComponentListener {
	public String from = "";
	private Frame fmc;
	private TextArea taMessage;
	private Button bSend;
	private Button bCancel;
	private Label lTo;
	private Label lSubject;
	private TextField tfTo;
	private TextField tfSubject;
	public String lable="MessageComposer";
	public boolean invisible = false;
public MessageComposer() {
	super();
}
/**
 * This method was created in VisualAge.
 * @param e java.awt.event.ActionEvent
 */
public void actionPerformed(ActionEvent e) {
	Object source = e.getSource();
	if (source == bSend) {
		Message msg = new Message();
		msg.setTo(tfTo.getText());
		msg.setSubject(tfSubject.getText());
		msg.setMsgBody(taMessage.getText());
		msg.setFrom(from);
		msg.setReturnPath(from);
		
		msg.create(); // very important
		
		MessageEvent me = new MessageEvent(this, msg);
		for (int i=0; i<messageListener.size(); i++) {
			MessageListener ml = (MessageListener) messageListener.elementAt(i);
			ml.handleMessage(me);
		}
		fmc.setVisible(false);
	} else if (source == bCancel) {
		fmc.setVisible(false);
	}
}
/**
 * This method was created in VisualAge.
 * @param e java.awt.event.ComponentEvent
 */
public void componentHidden(ComponentEvent e) {
}
/**
 * This method was created in VisualAge.
 * @param e java.awt.event.ComponentEvent
 */
public void componentMoved(ComponentEvent e) {
}
/**
 * This method was created in VisualAge.
 * @param e java.awt.event.ComponentEvent
 */
public void componentResized(ComponentEvent e) {
	resize();
}
/**
 * This method was created in VisualAge.
 * @param e java.awt.event.ComponentEvent
 */
public void componentShown(ComponentEvent e) {
	resize();
}
/**
 * This method was created in VisualAge.
 */
public void compose() {
	fmc = new Frame();
	fmc.addWindowListener(this);
	fmc.addComponentListener(this);
	fmc.setTitle("Message Composer");
	
	lTo = new Label("To: ");
	lTo.setAlignment(Label.RIGHT);
	fmc.add(lTo);
	tfTo = new TextField();
	fmc.add(tfTo);

	lSubject = new Label("Subject: ");
	lSubject.setAlignment(Label.RIGHT);
	fmc.add(lSubject);
	tfSubject = new TextField();
	fmc.add(tfSubject);
	
	bSend = new Button("Send");
	bSend.addActionListener(this);
	fmc.add(bSend);
	bCancel = new Button("Cancel");
	bCancel.addActionListener(this);
	fmc.add(bCancel);

	taMessage = new TextArea();
	fmc.add(taMessage);
	fmc.setSize(700,500);
	fmc.setVisible(true);
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public String getFrom() {
	return from;
}
/**
 * This method was created in VisualAge.
 * @return boolean
 */
public boolean getInvisible() {
	return invisible;
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public String getLable() {
	return lable;
}
/**
 * This method was created in VisualAge.
 * @return java.awt.Dimension
 */
public Dimension getPreferredSize() {
	return new Dimension(100,50);
}
/**
 * This method was created in VisualAge.
 * @param g java.awt.Graphics
 */
public void paint(Graphics g) {
	if (!invisible) {
		int width = getSize().width;
		int height = getSize().height;
		g.setColor(getBackground());
		g.fillRect(0,0, width-1, height-1);
		g.setColor(getForeground());
		g.setFont(getFont());
		FontMetrics fm = g.getFontMetrics();
		g.drawString(lable , (width-fm.stringWidth(lable))/2, (height+fm.getMaxAscent()-fm.getMaxDescent())/2);
		g.drawRect(0,0, width-1, height-1);
	}
}
/**
 * This method was created in VisualAge.
 */
public void resize() {
	Insets i = fmc.getInsets();
	lTo.setBounds(i.right+5, i.top+5, 70, 27);
	tfTo.setBounds(i.right+80, i.top+5, 400, 27);
	lSubject.setBounds(i.right+5, i.top+35, 70, 27);
	tfSubject.setBounds(i.right+80, i.top+35, 400, 27);
	bSend.setBounds(i.right+500, i.top+5, 80, 27);
	bCancel.setBounds(i.right+500, i.top+35, 80, 27);
	taMessage.setBounds(i.right, i.top+80, fmc.getSize().width-i.right-i.left, fmc.getSize().height-80-i.top-i.bottom);
}
/**
 * This method was created in VisualAge.
 * @param s java.lang.String
 */
public void setFrom(String s) {
	from = s;
}
/**
 * This method was created in VisualAge.
 * @param b boolean
 */
public void setInvisible(boolean b) {
	invisible = b;
}
/**
 * This method was created in VisualAge.
 * @param s java.lang.String
 */
public void setLable(String s) {
	lable = s;
}
/**
 * This method was created in VisualAge.
 * @param txt java.lang.String
 */
public void setMessageText(String txt) {
	taMessage.setText(txt);
}
/**
 * This method was created in VisualAge.
 * @param subject java.lang.String
 */
public void setSubject(String subject) {
	tfSubject.setText(subject);
}
/**
 * This method was created in VisualAge.
 * @param to java.lang.String
 */
public void setTo(String to) {
	tfTo.setText(to);
}
/**
 * This method was created in VisualAge.
 * @param e java.awt.event.WindowEvent
 */
public void windowActivated(WindowEvent e) {
}
/**
 * This method was created in VisualAge.
 * @param e java.awt.event.WindowEvent
 */
public void windowClosed(WindowEvent e) {
}
/**
 * This method was created in VisualAge.
 * @param e java.awt.event.WindowEvent
 */
public void windowClosing(WindowEvent e) {
	fmc.setVisible(false);
	fmc.dispose();
}
/**
 * This method was created in VisualAge.
 * @param e java.awt.event.WindowEvent
 */
public void windowDeactivated(WindowEvent e) {
}
/**
 * This method was created in VisualAge.
 * @param e java.awt.event.WindowEvent
 */
public void windowDeiconified(WindowEvent e) {
}
/**
 * This method was created in VisualAge.
 * @param e java.awt.event.WindowEvent
 */
public void windowIconified(WindowEvent e) {
}
/**
 * This method was created in VisualAge.
 * @param e java.awt.event.WindowEvent
 */
public void windowOpened(WindowEvent e) {
}
}