package mailbeans;

import java.awt.*;
import java.awt.event.*;
import java.util.*;
import mailbeans.viewers.*;
import java.io.*;
/**
 * This type was created in VisualAge.
 */
public class MessageViewer extends Component implements WindowListener, ActionListener, ComponentListener, MessageListener, SerializeDataListener {
	public String settingsFilename = "mv.cfg";

	private Frame mvFrame;
	public String lable="MessageViewer";
	public boolean invisible = false;
	private Message message;
	//private String mimeTypesPath="";
	private MimeTypes mimeTypes;
	private MimeViewers mimeViewers;

	private TextArea mvTextArea;	
	private Component mvComponent;

	private MenuBar mvMenuBar;
	private Menu mvMenuFile;
	private Menu mvMenuViewer;

	// MenuItems
	private String M_FILE = "File";
	private String M_VIEWER = "Viewer";
	private String MI_CLOSE = "Close";
	private String MI_EXPORT = "Export";
/**
 * MessageViewer1 constructor comment.
 */
public MessageViewer() {
	super();
	init();
}
/**
 * This method was created in VisualAge.
 * @param e java.awt.event.ActionEvent
 */
public void actionPerformed(ActionEvent e) {
	String cmd = e.getActionCommand();
	if (cmd.equals(MI_CLOSE)) {
		close();
	} else if (cmd.equals(MI_EXPORT)) {
		FileDialog fd = new FileDialog(mvFrame, "Export", FileDialog.SAVE);
		fd.show();
		if (message!=null && fd.getFile()!=null) message.export(fd.getDirectory()+fd.getFile());
	} else{
		boolean update = false;
		for (Enumeration en=mimeViewers.getViewers(((MimeMessage)message).getMimeConcreteType()).elements(); en.hasMoreElements();) {
			Viewer v = (Viewer)en.nextElement();
			mimeViewers.remove(v);
			if (cmd.equals(v.getViewerName())) {
				mimeViewers.select(v);
				update = true;
			}
		}
		if (update) {
			placeViewer();
			resize();				
		}
	}
}
/**
 * This method was created in VisualAge.
 */
public void close() {
	mvFrame.remove(mvComponent);
	mvComponent=null;
	//dispose();
	mvFrame.setVisible(false);
	message.freeMem();
}
/**
 * This method was created in VisualAge.
 * @param e java.awt.event.ComponentEvent
 */
public void componentHidden(ComponentEvent e) {
}
/**
 * This method was created in VisualAge.
 * @param e java.awt.event.ComponentEvent
 */
public void componentMoved(ComponentEvent e) {
}
/**
 * This method was created in VisualAge.
 * @param e java.awt.event.ComponentEvent
 */
public void componentResized(ComponentEvent e) {
	/*Insets insets = getInsets();
	mvTextArea.setBounds(insets.left, insets.top, getSize().width-insets.right-insets.left,70);
	mvComponent.setBounds(insets.left, insets.top+mvTextArea.getSize().height, getSize().width-insets.right-insets.left, getSize().height-mvTextArea.getSize().height-insets.top-insets.bottom);
*/
	resize();
	/*if (mvPanel!=null) {
		Insets insets = getInsets();
		//mvPanel.setBounds(insets.left, insets.top, getSize().width-insets.right-insets.left,70);
		mvPanel.setBounds(insets.left, insets.top, getSize().width-insets.right-insets.left, getSize().height-insets.top-insets.bottom);
	}*/
}
/**
 * This method was created in VisualAge.
 * @param e java.awt.event.ComponentEvent
 */
public void componentShown(ComponentEvent e) {
	/*Insets insets = getInsets();
	mvTextArea.setBounds(insets.left, insets.top, getSize().width-insets.right-insets.left,70);
	mvComponent.setBounds(insets.left, insets.top+mvTextArea.getSize().height, getSize().width-insets.right-insets.left, getSize().height-mvTextArea.getSize().height-insets.top-insets.bottom);
	*/
	
	resize();
}
/**
 * This method was created in VisualAge.
 * @return boolean
 */
public boolean getInvisible() {
	return invisible;
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public String getLable() {
	return lable;
}
/**
 * This method was created in VisualAge.
 * @return java.awt.Dimension
 */
public Dimension getPreferredSize() {
	return new Dimension(100,50);
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public String getSettingsFilename() {
	return settingsFilename;
}
/**
 * This method was created in VisualAge.
 * @param e MailBeans.MessageEvent
 */
public void handleMessage(MessageEvent e) {
}
/**
 * This method was created in VisualAge.
 */
public void init() {
	//mimeTypes = new MimeTypes("D:\\Mailbean");
	//mimeViewers = new MimeViewers("D:\\Mailbean");
	mimeTypes = new MimeTypes(System.getProperty("user.dir"));
	mimeViewers = new MimeViewers(System.getProperty("user.dir"));
	//System.out.println(System.getProperty("user.dir"));

	mvFrame = new Frame();
	mvFrame.addWindowListener(this);
	mvFrame.addComponentListener(this);
	mvFrame.setLayout(null);
	
	mvTextArea = new TextArea("",0,0,TextArea.SCROLLBARS_NONE);
	mvTextArea.setEditable(false);
	mvFrame.add(mvTextArea);

	mvMenuBar = new MenuBar();
	mvMenuFile = new Menu(M_FILE);
	mvMenuBar.add(mvMenuFile);
	mvMenuViewer = new Menu(M_VIEWER);
	mvMenuBar.add(mvMenuViewer);
	mvFrame.setMenuBar(mvMenuBar);

	MenuItem mi;
	mi = new MenuItem(MI_EXPORT);
	mi.addActionListener(this);
	mvMenuFile.add(mi);
	mvMenuFile.insertSeparator(1);
	mi = new MenuItem(MI_CLOSE);
	mi.addActionListener(this);
	mvMenuFile.add(mi);

	mvFrame.setSize(500,400);	
}
/**
 * This method was created in VisualAge.
 * @param g java.awt.Graphics
 */
public void paint(Graphics g) {
	if (!invisible) {
		int width = getSize().width;
		int height = getSize().height;
		g.setColor(getBackground());
		g.fillRect(0,0, width-1, height-1);
		g.setColor(getForeground());
		g.setFont(getFont());
		FontMetrics fm = g.getFontMetrics();
		g.drawString(lable , (width-fm.stringWidth(lable))/2, (height+fm.getMaxAscent()-fm.getMaxDescent())/2);
		g.drawRect(0,0, width-1, height-1);
	}
}
/**
 * This method was created in VisualAge.
 */
private void placeViewer() {
	MimeMessage mimeMsg = null;
	if (message instanceof MimeMessage) {
		mimeMsg=(MimeMessage)message;
	}
	if (mimeMsg!=null) {
		if (mvComponent!=null) mvFrame.remove(mvComponent);
		Viewer selectedViewer=null;
		int counter=0;
		for (Enumeration en=mimeViewers.getViewers(mimeMsg.getMimeConcreteType()).elements(); en.hasMoreElements();) {
			Viewer v=(Viewer)en.nextElement();
			if (mimeViewers.isSelected(v)) {
				selectedViewer=v;
				counter++;
			}
		}
		if (counter==1) {
			mvComponent=selectedViewer.view(); //.view(mimeMsg.getMimeConcreteType());
		}
		else if (counter==0) {
		}
		if (mvComponent==null) {
			// select default viewer
			ViewerDefault vd = new ViewerDefault();
			vd.setMimeConcreteType(mimeMsg.getMimeConcreteType());
			mvComponent=vd.view(); //.view(mimeMsg.getMimeConcreteType());
		}
	} else {
		TextArea ta = new TextArea();
		ta.append(message.getMsgBodyString());
		mvComponent=ta;
	}
	mvFrame.add(mvComponent);
}
/**
 * This method was created in VisualAge.
 * @param s java.io.ObjectInputStream
 * @exception java.io.IOException The exception description.
 */
public void readData(SerializeDataEvent e) {
	ObjectInputStream in = e.getObjectInputStream();
	try {
		mimeViewers.readData(in);
	} catch (IOException ex) {
		System.out.println("IOException in mailbeans.MessageViewer.readProperties(): "+ex.getMessage());
	}
}
/**
 * This method was created in VisualAge.
 * @return 
 */
private void resize() {
	Insets insets = mvFrame.getInsets();
	int width = mvFrame.getSize().width;
	int height = mvFrame.getSize().height;
	mvTextArea.setBounds(insets.left, insets.top, width-insets.right-insets.left,70);
	mvComponent.setBounds(insets.left, insets.top+mvTextArea.getSize().height, width-insets.right-insets.left, height-mvTextArea.getSize().height-insets.top-insets.bottom);
}
/**
 * This method was created in VisualAge.
 * @param b boolean
 */
public void setInvisible(boolean b) {
	invisible = b;
}
/**
 * This method was created in VisualAge.
 * @param s java.lang.String
 */
public void setLable(String s) {
	lable = s;
}
/**
 * This method was created in VisualAge.
 * @param s java.lang.String
 */
public void setSettingsFilename(String s) {
	settingsFilename = s;
}
/**
 * This method was created in VisualAge.
 * @param e MailBeans.MessageEvent
 */
public void showMessage(MessageEvent e) {
	MimeMessage mimeMsg=null;
	if (e!=null) {
		message = e.getMessage();
		mvMenuViewer.removeAll();
		if ((mimeTypes!=null) && (message instanceof MimeMessage)) {
			mimeMsg = (MimeMessage)message;
			mimeMsg.parse(mimeTypes);
			
			for (Enumeration en=mimeViewers.getViewers(mimeMsg.getMimeConcreteType()).elements(); en.hasMoreElements();) {
			Viewer v = (Viewer)en.nextElement();
			if (v.fits()) {
				MenuItem mi = new MenuItem(v.getViewerName());
				mi.addActionListener(this);
				mvMenuViewer.add(mi);
			}
		}
		}

		mvFrame.setTitle(message.getFrom()+", "+message.getSubject());
		StringBuffer sb = new StringBuffer();
		sb.append("From: "+message.getFrom()+"\n");
		sb.append("Subject: "+message.getSubject()+"\n");
		sb.append("Date: "+message.getDate()+"\n");
		mvTextArea.setText(sb.toString());

		//mvMenuViewer.removeAll();
		
		placeViewer();
		mvFrame.setVisible(true);
	}
}
/**
 * This method was created in VisualAge.
 * @param e java.awt.event.WindowEvent
 */
public void windowActivated(WindowEvent e) {
}
/**
 * This method was created in VisualAge.
 * @param e java.awt.event.WindowEvent
 */
public void windowClosed(WindowEvent e) {
}
/**
 * This method was created in VisualAge.
 * @param e java.awt.event.WindowEvent
 */
public void windowClosing(WindowEvent e) {
	close();
}
/**
 * This method was created in VisualAge.
 * @param e java.awt.event.WindowEvent
 */
public void windowDeactivated(WindowEvent e) {
}
/**
 * This method was created in VisualAge.
 * @param e java.awt.event.WindowEvent
 */
public void windowDeiconified(WindowEvent e) {
}
/**
 * This method was created in VisualAge.
 * @param e java.awt.event.WindowEvent
 */
public void windowIconified(WindowEvent e) {
}
/**
 * This method was created in VisualAge.
 * @param e java.awt.event.WindowEvent
 */
public void windowOpened(WindowEvent e) {
}
/**
 * This method was created in VisualAge.
 * @param s java.io.ObjectOutputStream
 * @exception java.io.IOException The exception description.
 */
public void writeData(SerializeDataEvent e) {
	ObjectOutputStream out = e.getObjectOutputStream();
	try {
		mimeViewers.writeData(out);
	} catch (IOException ex) {
		System.out.println("IOExcepion in mailbeans.MessageViewer.writeProperties(): "+ex.getMessage());
	}
	
}
}