package mailbeans;

import java.util.*;
import java.awt.*;
/**
 * This type was created in VisualAge.
 */
public abstract class MimeConcreteType {
	protected String contentType;
	protected String contentDescription;
	protected String contentTransferEncoding;
	protected String contentID;
	protected String type;
	protected String subtype;
	protected String parameter;
	protected String[] msg;
	private int currFilePos = -1;
/**
 * ConcretMimeType constructor comment.
 */
public MimeConcreteType() {
	super();
	init();
}
/**
 * This method was created in VisualAge.
 * @param msg java.lang.String
 */
public MimeConcreteType(String[] msg) {
	init();
	this.msg = msg;
}
/**
 * This method was created in VisualAge.
 * @return boolean
 */
public boolean eof() {
	if (currFilePos<msg.length) {
		return true;
	}
	currFilePos = -1;
	return false;
}
/**
 * This method was created in VisualAge.
 * @return java.awt.Component
 */
public Component getComponent() {
	TextArea ta = new TextArea();
	ta.setText(getMsgBodyString());
	return ta;
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public String getContentDescription() {
	if (msg!=null && contentDescription=="") {
		int i = 0;
		while (i<msg.length && !(msg[i].toLowerCase().startsWith("content-description:"))) i++;
		if (i<msg.length) contentDescription = msg[i].substring(20);
	}
	return contentDescription.trim();
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public String getContentID() {
	if (contentID=="") {
		contentID=getFieldText("content-id:");
	}
	return contentID;
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public String getContentTransferEncoding() {
	if (contentTransferEncoding=="") {
		contentTransferEncoding=getFieldText("content-transfer-encoding:");
	}
	return contentTransferEncoding;
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public String getContentType() {
	if (contentType=="") {
		contentType = getFieldText("content-type:");
	}
	return contentType;
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 * @param field java.lang.String
 */
private String getFieldText(String field) {
	String str = "";
	if (msg!=null) {
		int i = 0;
		while (i<msg.length && !(msg[i].toLowerCase().startsWith(field))) i++;
		if (i<msg.length) {
			str = msg[i].substring(field.length());
			i++;
			while (i<msg.length && msg[i].length()>0 && ((msg[i].charAt(0)=='\t')||(msg[i].charAt(0)==' '))) {
				str = str +msg[i].substring(1);
				i++;
			}
		}
	}
	return str.trim();
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public String getMimeType() {
	return null;
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String[]
 */
public String[] getMsgBody() {
	String[] str=null;
	int i=0;
	while (i<msg.length && msg[i].length()!=0) i++;
	if (i<msg.length) {
		str = new String[msg.length-i];
		for (int j=0; j<str.length; j++) str[j] = msg[j+i];
		
	}
	return str;
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public String getMsgBodyString() {
	StringBuffer sb = new StringBuffer();
	if (msg==null) {
		//sb.append(msgBody+"\n");
	} else {
		int i=0;
		while (i<msg.length && msg[i].length()!=0) i++;
		while (i<msg.length && msg[i]!=".") {
			sb.append(msg[i++]+"\n");
		}
	}
	return sb.toString();
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public String getParameter() {
	if (parameter=="") parseContentType();
	return parameter.trim();
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public String getSubType() {
	if (subtype=="") parseContentType();
	return subtype.trim();
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public String getType() {
	if (type=="") parseContentType();
	return type.trim();
}
/**
 * This method was created in VisualAge.
 */
public void init() {
	contentType = "";
	contentDescription = "";
	contentTransferEncoding = "";
	contentID = "";
	type = "";
	subtype = "";
	parameter = "";
	msg = null;
	
}
/**
 * This method was created in VisualAge.
 * @return java.lang.Object
 */
public String nextString() {
	if (currFilePos==-1) {
		currFilePos = 0;
		while (currFilePos<msg.length && msg[currFilePos].length()!=0) currFilePos++;
	}
	if (currFilePos<msg.length) {
		return msg[currFilePos++];
	} 
	return null;
}
/**
 * This method was created in VisualAge.
 */
public void parseContentType() {
	StringTokenizer st = new StringTokenizer(getContentType(), "/;");
	int i = 0;
	while (st.hasMoreTokens() && i<3) {
		switch(i) {
			case 0: type = st.nextToken(); break;
			case 1: subtype = st.nextToken(); break;
			case 2: parameter = st.nextToken(); break;
			default: st.nextToken();
		}
		i++;
	}
}
/**
 * This method was created in VisualAge.
 * @param type java.lang.String
 */
public void setType(String type) {
	this.type = type;
}
}