package mailbeans;

import java.util.*;
import java.awt.*;
/**
 * This type was created in VisualAge.
 */
public class MimeMessage extends Message {
	private String mimeVersion;
	private String contentType;
	private String contentDescription;
	private String contentTransferEncoding;
	private String contentID;
	private MimeConcreteType concreteType;
/**
 * MimeMessage constructor comment.
 */
public MimeMessage() {
	super();
}
/**
 * MimeMessage constructor comment.
 * @param msg java.lang.String[]
 */
public MimeMessage(java.lang.String[] msg) {
	super(msg); // The init() and store() methods are called in the constructor Message(String[])
}
/**
 * This method was created in VisualAge.
 */
public void freeMem() {
	concreteType = null;
	super.freeMem();
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public String getContentDescription() {
	if (msg!=null && contentDescription=="") {
		int i = 0;
		while (i<msg.length && !(msg[i].toLowerCase().startsWith("content-description:"))) i++;
		if (i<msg.length) contentDescription = msg[i].substring(20);
	}
	return contentDescription.trim();
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public String getContentID() {
	if (msg!=null && contentID=="") {
		int i = 0;
		while (i<msg.length && !(msg[i].toLowerCase().startsWith("content-id:"))) i++;
		if (i<msg.length) contentTransferEncoding = msg[i].substring(11);
	}
	return contentID.trim();
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public String getContentTransferEncoding() {
	if (msg!=null && contentTransferEncoding=="") {
		int i = 0;
		while (i<msg.length && !(msg[i].toLowerCase().startsWith("content-transfer-encoding:"))) i++;
		if (i<msg.length) contentTransferEncoding = msg[i].substring(26);
	}
	return contentTransferEncoding.trim();
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public String getContentType() {
	if (msg!=null && contentType=="") {
		/*int i = 0;
		while (i<msg.length && !(msg[i].toLowerCase().startsWith("content-type:"))) i++;
		if (i<msg.length) contentType = msg[i].substring(13);*/
		contentType = getFieldText("content-type:");
	}
	//return contentType.trim();
	return contentType;
}
/**
 * This method was created in VisualAge.
 * @return MailBeans.MimeConcreteType
 */
public MimeConcreteType getMimeConcreteType() {
	return concreteType;
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public String getMimeVersion() {
	if (msg!=null && mimeVersion=="") {
		char[] vstr = new char[10]; // i think the verionnumber is never longer than 10 characters
		int m = 0;
		int n = 0;
		int i=0;
		while (i<msg.length && !(msg[i].toLowerCase().startsWith("mime-version:"))) i++;
		if (i<msg.length) {
			String str = msg[i].substring(13);
			while (m<vstr.length && n<str.length()) {
				if (str.charAt(n)=='(') {
					while (m<vstr.length && n<str.length() && str.charAt(n)!=')' ) {
						n++;
					}
				} else {
					vstr[m++]=str.charAt(n);
				}
				n++;
			}
		}
		String ret = new String(vstr,0,m);
		mimeVersion = ret.trim();
	}
	
	return mimeVersion.trim();
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public String[] getMsgBody() {
	String[] str = null;
	if (msg==null) load();
	if (concreteType==null) {
		int i=0;
		while (i<msg.length && msg[i].length()!=0) i++;
		if (i<msg.length) {
			str = new String[msg.length-i+5];
			str[0]="Content-Type: "+getContentType();
			str[1]="Content-Transfer-Encoding: "+getContentTransferEncoding();
			str[2]="Content-ID: "+getContentID();
			str[3]="Content-Description: "+getContentDescription();
			str[4]="";
			for (int j=5; j<str.length; j++) {
				str[j] = msg[i++];
			}
		}
	} else {
		str = concreteType.getMsgBody();
	}
	return str;
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public String getMsgBodyString() {
	if (concreteType!=null) return concreteType.getMsgBodyString();
	return super.getMsgBodyString();
}
/**
 * This method was created in VisualAge.
 */
public void init() {
	// This method is called in the constructor Message(String[])
	//System.out.println("MimeMessage.init()");
	super.init();
	mimeVersion = "";
	contentType = "";
	contentDescription = "";
	contentTransferEncoding = "";
	contentID = "";
	concreteType = null;
	if (msg!=null) {
		mimeVersion = getFieldText("mime-version:");
		if (mimeVersion!="") {
			contentType = getFieldText("content-type:");
			contentDescription = getFieldText("content-description:");	
			contentTransferEncoding = getFieldText("content-transfer-encoding:");
			contentID = getFieldText("content-id:");
		}
	}
}
/**
 * This method was created in VisualAge.
 */
public void parse(MimeTypes mimeTypes) {
	if (msg==null) load();	
	concreteType = null; // This is because gmtMsgBody() checks if concreteType is null
	concreteType = mimeTypes.getMimeConcreteType(getMsgBody());
}
/**
 * This method was created in VisualAge.
 * @param contentType java.lang.String
 */
public void setContentType(String contentType) {
	this.contentType = contentType;
}
/**
 * This method was created in VisualAge.
 * @param mimeVersion java.lang.String
 */
public void setMimeVersion(String mimeVersion) {
	this.mimeVersion = mimeVersion;
}
}