package mailbeans;

import java.util.*;
import java.io.*;
/**
 * This type was created in VisualAge.
 */
public class MimeTypes {
	Vector concreteType = new Vector();
	Vector mimeTypes = new Vector();
	String path;
/**
 * MimeType constructor comment.
 */
public MimeTypes(String path) {
	super();
	this.path = path;
	init();
}
/**
 * This method was created in VisualAge.
 * @param type MailBean.ConcretMimeType
 */
public void addMimeConcreteType(MimeConcreteType type) {
	concreteType.addElement(type);
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 * @param msg java.lang.String[]
 */
public String getContentType(String[] msg) {
	String str = "";
	if (msg!=null) {
		int i = 0;
		while (i<msg.length && !(msg[i].toLowerCase().startsWith("content-type:"))) i++;
		if (i<msg.length) str = msg[i].substring(13);
	}
	return str.trim();
}
/**
 * This method was created in VisualAge.
 * @return ConcreteMimeType
 * @param contentType java.lang.String
 */
public MimeConcreteType getMimeConcreteType(String[] msg) {
	for (Enumeration e=concreteType.elements(); e.hasMoreElements();) {
		MimeConcreteType mct =(MimeConcreteType)e.nextElement();
		if (getContentType(msg).toLowerCase().startsWith(mct.getMimeType().toLowerCase())) {  // looking for the right mimeType
			Class c = mct.getClass();
			Object obj = null;
			Object[] param = null;

			java.lang.reflect.Constructor con = null;
			try {
				con = c.getConstructor(new Class[] { msg.getClass(), getClass()});
				param = new Object[] {msg, this};
			} catch (NoSuchMethodException ex) {
				try {
					con = c.getConstructor(new Class[] {msg.getClass()});
					param = new Object[] {msg};
				} catch (NoSuchMethodException ex1) {
					System.out.println("NoSuchMethodException1: "+ex1.getMessage());
				}
				//System.out.println("NoSuchMethodException: "+ex.getMessage());
			}
			if (con!=null && param!=null) {
				try {
					obj = con.newInstance(param);	// Create new Instance with right constructor
				} catch (InstantiationException ex) {
					System.out.println("InstantiationException: "+ex.getMessage());
				} catch (IllegalAccessException ex) {
					System.out.println("IllegalAccessException: "+ex.getMessage());
				} catch (java.lang.reflect.InvocationTargetException ex) {
					System.out.println("InvocationTargetException "+ex.getMessage());
				}
			}
			if (obj instanceof MimeConcreteType)
				return (MimeConcreteType)obj;
		}
	}
	return new MimeTypeDefault(msg);
}
/**
 * This method was created in VisualAge.
 */
public void init() {
	MimeTypesLoader mtl = new MimeTypesLoader(path);
	/*for (Enumeration e=mtl.elements(); e.hasMoreElements();) {
		addMimeConcreteType((MimeConcreteType)e.nextElement());
	}*/
	concreteType = mtl.getMimeTypes();
	/*addMimeConcreteType(new MimeTypeMultipart());
	addMimeConcreteType(new MimeTypeText());*/
}
}