package mailbeans;

import java.util.*;
import java.io.*;
/**
 * This type was created in VisualAge.
 */
public class MimeViewers {
	Vector viewersClass = new Vector();
	Vector selectedViewer = new Vector();
	String path;
/**
 * MimeViewers constructor comment.
 */
public MimeViewers(String path) {
	super();
	this.path = path;
	//ViewerLoader vl = new ViewerLoader(path);
	//load(path); is called in getViewers(..)
	//viewers = vl.getViewers();
}
/**
 * This method was created in VisualAge.
 * @return java.util.Vector
 * @param mct mailbeans.MimeConcreteType
 */
public Vector getViewers(MimeConcreteType mct) {
	load(path);
	if (mct != null) {
		Vector viewerfits = new Vector();
		for (Enumeration e=viewersClass.elements(); e.hasMoreElements();) {
			//Viewer v =(Class)e.nextElement();
			
			Class c = (Class)e.nextElement();
			Object obj = null;
			Object[] param = null;

/*			try {
				obj = c.newInstance();
			} catch (InstantiationException ex) {
				System.out.println("InstantiationException: "+ex.getMessage());
			} catch (IllegalAccessException ex) {
				System.out.println("IllegalAccessException: "+ex.getMessage());
			}*/
			

			java.lang.reflect.Constructor con = null;
			try {
				con = c.getConstructor(new Class[] {getClass()});
				param = new Object[] {this};
			} catch (NoSuchMethodException ex) {
				try {
					con = c.getConstructor(new Class[] { });
					param = con.getParameterTypes();
					/*java.lang.reflect.Constructor[] ac = c.getConstructors();
					for( int i=0; i<ac.length; i++) {
						if ((ac[i].getParameterTypes()).length==0) {
							con = ac[i];
						}
					}*/
					//con = c.getConstructor(new Class[] { });
					//param = new Object[] { };
				} catch (NoSuchMethodException ex1) {
					System.out.println("NoSuchMethodException: "+ex1.getMessage()+" in class " +c.getName());
				}
				//System.out.println("NoSuchMethodException: "+ex.getMessage());
			}
			if (con!=null) {
				try {
					if (param!=null) {
						obj = con.newInstance(param);	// Create new Instance with right constructor
					} else {
						obj = c.newInstance();
					}
				} catch (InstantiationException ex) {
					System.out.println("InstantiationException: "+ex.getMessage());
				} catch (IllegalAccessException ex) {
					System.out.println("IllegalAccessException: "+ex.getMessage());
				} catch (java.lang.reflect.InvocationTargetException ex) {
					System.out.println("InvocationTargetException "+ex.getMessage());
				}
			} 
			if (obj instanceof Viewer) {
				((Viewer)obj).setMimeConcreteType(mct);
				if (((Viewer)obj).fits()) viewerfits.addElement(obj);
			}
		}
		return viewerfits;
	}
	return null;
}
/**
 * This method was created in VisualAge.
 * @return boolean
 * @param v mailbeans.Viewer
 */
public boolean isSelected(Viewer v) {
	//int inx = 0;
	return (selectedViewer.indexOf(v.getViewerName())>-1);
	//return false;
}
/**
 * This method was created in VisualAge.
 */
public void load(String path) {
	SimpleClassLoader sc = new SimpleClassLoader();
	Object o;
	String[] files;
	viewersClass = new Vector();
	//java.io.File f = new java.io.File(path+"\\mailbeans\\viewers");
	File f = new File(path+File.separatorChar+"mailbeans"+File.separatorChar+"viewers");
	//System.out.println("MimeViewers load: "+path+File.separatorChar+"mailbeans"+File.separatorChar+"viewers");
	String str[] = f.list();
	if (str!=null) {
		for (int i=0; i<str.length; i++) {
			if ((str[i].toLowerCase()).endsWith(".class")) {
				try {
					Class c = sc.loadClass("mailbeans.viewers."+str[i].substring(0,str[i].length()-6));
					viewersClass.addElement(c);
				} catch (Exception e) {
					System.out.println("Exception: "+e);
				}
			}
		}
	}
}
/**
 * This method was created in VisualAge.
 * @param s java.io.ObjectInputStream
 * @exception java.io.IOException The exception description.
 */
public void readData(ObjectInputStream s) throws IOException {
	try {
		selectedViewer = (Vector)s.readObject();
	} catch (ClassNotFoundException ex) {
		throw new IOException(ex.getMessage());
	}
}
/**
 * This method was created in VisualAge.
 * @param v mailbeans.Viewer
 */
public void remove(Viewer v) {
	if (selectedViewer.contains(v.getViewerName()))
		selectedViewer.removeElement(v.getViewerName());
}
/**
 * This method was created in VisualAge.
 * @param v mailbeans.Viewer
 */
public void select(Viewer v) {
	if (!selectedViewer.contains(v.getViewerName()))
		selectedViewer.addElement(v.getViewerName());
}
/**
 * This method was created in VisualAge.
 * @param s java.io.ObjectOutputStream
 * @exception java.io.IOException The exception description.
 */
public void writeData(ObjectOutputStream s) throws IOException {
	s.writeObject(selectedViewer);
}
}