package mailbeans;

import java.io.*;
import java.util.*;
import java.beans.*;
import java.awt.*;
/**
 * This class implementes POP3 (Post Office Protocol 3).
 * 
 */
public class SMTP extends MailBeansComponent implements mailbeans.MessageListener {
	Transport trans;
	String servername = "";
	boolean invisible = false;
	String lable="SMTP";
	
	protected java.io.DataInputStream inStream;
	protected java.io.DataOutputStream outStream;
	private java.util.Vector msgList = new Vector();
	//private int currentMsg;
/**
 * This method was created in VisualAge.
 */
public SMTP() {
	super();
}
/**
 * This method was created in VisualAge.
 * @return boolean
 */
public boolean getInvisible() {
	return invisible;
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public String getLable() {
	return lable;
}
/**
 * This method was created in VisualAge.
 * @return java.awt.Dimension
 */
public Dimension getMinimumSize() {
	return new Dimension(50,50);
}
/**
 * This method was created in VisualAge.
 * @return java.awt.Dimension
 */
public Dimension getPreferredSize() {
	return new Dimension(100,50);
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public String getServername() {
	return servername;
}
/**
 * This method was created in VisualAge.
 * @param e mailbeans.MessageEvent
 */
public void handleMessage(mailbeans.MessageEvent e) {
	try {
		open();
		logon();
		int i = 0;
		/*int size = msgSender.msgSize();
		for (Enumeration e = msgSender.elements(); e.hasMoreElements();) {
			i++;
			output("sending message "+i+"of "+size);
			
			send((Message)e.nextElement());
		}*/
		output("sending message");
			
		send((Message)e.getMessage());
		
		quit();
	} catch (IOException ex) {
		System.out.println("IOException: "+ex.getMessage());
	}

}
/**
 * This method was created by a SmartGuide.
 * @param input java.lang.String
 */
private boolean isErrorResponse (String response) {
	return !response.startsWith("250");
}
/**
 * This method was created by a SmartGuide.
 * @exception IOException
 */
private void logon ( ) throws IOException {
	output("logon to SMTP: "+servername);
	String response = trans.doCommand("HELO unknown");
	if (isErrorResponse(response)) {
		throw new IOException(response);
	}
}
/**
 * This method was created in VisualAge.
 */
private void open() throws IOException {
	output("open connection to SMTP: "+servername);
	trans = new Transport(servername, 25);
	if (trans!=null) {
		trans.open();
	}
}
/**
 * This method was created in VisualAge.
 */
public void output(String text) {
	OutputEvent e = new OutputEvent(this, text);
	for (int i=0; i<outputListener.size(); i++) {
		OutputListener ml = (OutputListener) outputListener.elementAt(i);
		ml.handleOutput(e);
	}
}
/**
 * This method was created in VisualAge.
 * @param g java.awt.Graphics
 */
public void paint(Graphics g) {
	if (!invisible) {
		int width = getSize().width;
		int height = getSize().height;
		g.setColor(getBackground());
		g.fillRect(0,0, width-1, height-1);
		g.setColor(getForeground());
		g.setFont(getFont());
		FontMetrics fm = g.getFontMetrics();
		g.drawString(lable , (width-fm.stringWidth(lable))/2, (height+fm.getMaxAscent()-fm.getMaxDescent())/2);
		g.drawRect(0,0, width-1, height-1);
	}
}
/**
 * This method was created by a SmartGuide.
 */
private void quit ( ) throws IOException {
	output("disconnect");
	trans.doCommand("QUIT");
	trans.close();
}
/**
 * This method was created in VisualAge.
 * @return Message
 * @param nr int
 * @exception java.io.IOException The exception description.
 */
private void send(Message msg) throws IOException {
	String response;
	response = trans.doCommand("MAIL FROM: "+msg.getFrom());
	if (isErrorResponse(response)) {
		throw new IOException(response);
	}
	response = trans.doCommand("RCPT TO: "+msg.getTo());
	if (isErrorResponse(response)) {
		throw new IOException(response);
	}
	
	response = trans.doCommand("DATA");
	if (!response.startsWith("354")) {
		throw new IOException(response);
	}
	
	/* Send Data here */
		
	response=trans.send(msg.getMsg(),".");
	if (isErrorResponse(response)) {
		throw new IOException(response);
	}
	
}
/**
 * This method was created in VisualAge.
 * @param b boolean
 */
public void setInvisible(boolean b) {
	invisible = b;
}
/**
 * This method was created in VisualAge.
 * @param s java.lang.String
 */
public void setLable(String s) {
	lable = s;
}
/**
 * This method was created in VisualAge.
 * @param servername java.lang.String
 */
public void setServername(String servername) {
	this.servername = servername;
}
/**
 * This method was created in VisualAge.
 * @param e mailbeans.MessageEvent
 */
public void showMessage(mailbeans.MessageEvent e) {
}
}