package mailbeans;

import java.awt.*;
import java.io.*;
import java.util.*;
import java.beans.*;
/**
 * This type was created in VisualAge.
 */
public class SerializeData extends Component implements OutputListener {
	public String lable="SerializeData";
	public boolean invisible = false;
	public String filename = "";
	private Vector serializeDataListener = new Vector();
	private Frame frame;
	private Window window;
	private Label label;
	protected transient PropertyChangeSupport propertyChange;
/**
 * SerializeSettings constructor comment.
 */
public SerializeData() {
	super();
}
/**
 * The addPropertyChangeListener method was generated to support the propertyChange field.
 */
public synchronized void addPropertyChangeListener(PropertyChangeListener listener) {
	getPropertyChange().addPropertyChangeListener(listener);
}
/**
 * This method was created in VisualAge.
 * @param l ActionListener
 */
public void addSerializeDataListener(SerializeDataListener l) {
	serializeDataListener.addElement(l);
}
/**
 * The firePropertyChange method was generated to support the propertyChange field.
 */
public void firePropertyChange(String propertyName, Object oldValue, Object newValue) {
	getPropertyChange().firePropertyChange(propertyName, oldValue, newValue);
}
/**
 * This method was created in VisualAge.
 */
public void fireReadData() {
	showStatus();
	setStatusText("Reading settings ...");
	try {
		FileInputStream in = new FileInputStream(filename);
		ObjectInputStream s = new ObjectInputStream(in);
		
		SerializeDataEvent e = new SerializeDataEvent(this, s);
		for (int i=0; i<serializeDataListener.size(); i++) {
			SerializeDataListener sdl = (SerializeDataListener) serializeDataListener.elementAt(i);
			sdl.readData(e);
		}

		s.close();
	} catch (IOException ex) {
		System.out.println("IOException: "+ex.getMessage());
	}
	hideStatus();
}
/**
 * This method was created in VisualAge.
 */
public void fireWriteData() {
	showStatus();
	setStatusText("Writing settings ...");
	try {
		FileOutputStream out = new FileOutputStream(filename);
		ObjectOutputStream s = new ObjectOutputStream(out);
		
		SerializeDataEvent e = new SerializeDataEvent(this, s);
		for (int i=0; i<serializeDataListener.size(); i++) {
			SerializeDataListener sdl = (SerializeDataListener) serializeDataListener.elementAt(i);
			sdl.writeData(e);
		}
		s.close();
	} catch (IOException ex) {
		System.out.println("IOException: "+ex.getMessage());
	}
	hideStatus();
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public String getFilename() {
	return filename;
}
/**
 * This method was created in VisualAge.
 * @return boolean
 */
public boolean getInvisible() {
	return invisible;
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public String getLable() {
	return lable;
}
/**
 * This method was created in VisualAge.
 * @return java.awt.Dimension
 */
public Dimension getPreferredSize() {
	return new Dimension(100,50);
}
/**
 * Accessor for the propertyChange field.
 */
protected PropertyChangeSupport getPropertyChange() {
	if (propertyChange == null) {
		propertyChange = new java.beans.PropertyChangeSupport(this);
	};
	return propertyChange;
}
/**
 * This method was created in VisualAge.
 * @param e MailBeans.OutputEvent
 */
public void handleOutput(OutputEvent e) {
	if (e!=null) {
		setStatusText(e.getText());
	}
}
/**
 * This method was created in VisualAge.
 */
public void hideStatus() {
	window.dispose();
}
/**
 * This method was created in VisualAge.
 * @param g java.awt.Graphics
 */
public void paint(Graphics g) {
	if (!invisible) {
		int width = getSize().width;
		int height = getSize().height;
		g.setColor(getBackground());
		g.fillRect(0,0, width-1, height-1);
		g.setColor(getForeground());
		g.setFont(getFont());
		FontMetrics fm = g.getFontMetrics();
		g.drawString(lable , (width-fm.stringWidth(lable))/2, (height+fm.getMaxAscent()-fm.getMaxDescent())/2);
		g.drawRect(0,0, width-1, height-1);
	}
}
/**
 * The removePropertyChangeListener method was generated to support the propertyChange field.
 */
public synchronized void removePropertyChangeListener(PropertyChangeListener listener) {
	getPropertyChange().removePropertyChangeListener(listener);
}
/**
 * This method was created in VisualAge.
 * @param l java.awt.event.ActionListener
 */
public void removeSerializeDataListener(SerializeDataListener l) {
	serializeDataListener.removeElement(l);
}
/**
 * This method was created in VisualAge.
 * @param s java.lang.String
 */
public void setFilename(String s) {
	filename = s;
}
/**
 * This method was created in VisualAge.
 * @param b boolean
 */
public void setInvisible(boolean b) {
	invisible = b;
}
/**
 * This method was created in VisualAge.
 * @param s java.lang.String
 */
public void setLable(String s) {
	lable = s;
}
/**
 * This method was created in VisualAge.
 * @param s java.lang.String
 */
public void setStatusText(String s) {
	label.setText(s);
}
/**
 * This method was created in VisualAge.
 * @param s java.lang.String
 */
public void showStatus() {
	//frame = new Frame();
	//frame.setLayout(new BorderLayout());
	window = new Dialog(new Frame());
	window.setLayout(new BorderLayout());
	
	window.setSize(300,60);
	
	label = new Label();
	label.setAlignment(Label.CENTER);
	window.add(label);
	window.show();
}
}