package mailbeans;

import java.awt.*;
import java.awt.event.*;
import java.beans.*;
import java.io.*;
/**
 * This type was created in VisualAge.
 */
public class SettingsDialog extends MenuItem implements ActionListener, WindowListener, Serializable, SerializeDataListener {
	public String email = "";
	public String popServer = "";
	public String popUsername ="";
	public String popPassword ="";
	public String smtpServer ="";
	
	private Frame sdFrame;
	private Panel sdPanel;
	private Label lPop;
	private Label lPopServer;
	private Label lPopPassword;
	private Label lPopUsername;
	private Label lSmtp;
	private Label lSmtpServer;
	private Label lEmail;
	private TextField tfPopServer;
	private TextField tfPopPassword;
	private TextField tfPopUsername;
	private TextField tfSmtpServer;
	private TextField tfEmail;
	private Button bOk;
	private Button bCancel;

	private PropertyChangeSupport changes = new PropertyChangeSupport(this);
/**
 * SettingsDialog constructor comment.
 */
public SettingsDialog() {
	super();
	init();
}
/**
 * SettingsDialog constructor comment.
 * @param label java.lang.String
 */
public SettingsDialog(String label) {
	super(label);
	init();
}
/**
 * SettingsDialog constructor comment.
 * @param label java.lang.String
 * @param s java.awt.MenuShortcut
 */
public SettingsDialog(String label, java.awt.MenuShortcut s) {
	super(label, s);
	init();
}
/**
 * actionPerformed method comment.
 */
public void actionPerformed(java.awt.event.ActionEvent e) {
	Object source = e.getSource();
	if (source == bOk) {
		setEmail(tfEmail.getText());
		setPopServer(tfPopServer.getText());
		setPopUsername(tfPopUsername.getText());
		setPopPassword(tfPopPassword.getText());
		setSmtpServer(tfSmtpServer.getText());
		sdFrame.dispose();
	} else
	if (source == bCancel) {
		sdFrame.dispose();
	} else
	if (source == this) {
		open();
	}
}
/**
 * This method was created in VisualAge.
 * @param l java.beans.PropertyChangeListener
 */
public void addPropertyChangeListener(PropertyChangeListener l) {
	changes.addPropertyChangeListener(l);
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public String getEmail() {
	return email;
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public String getPopPassword() {
	return popPassword;
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public String getPopServer() {
	return popServer;
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public String getPopUsername() {
	return popUsername;
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public String getSmtpServer() {
	return smtpServer;
}
/**
 * This method was created in VisualAge.
 */
public void init() {
	addActionListener(this);
}
/**
 * This method was created in VisualAge.
 */
public void open() {
	sdFrame = new Frame("Settings Dialog");
	sdFrame.setLayout(new BorderLayout());
	sdFrame.setSize(400,400);
	sdFrame.addWindowListener(this);
	sdPanel = new Panel();
	sdPanel.setLayout(null);
	
	lEmail = new Label("Enter your e-mail adress:");
	sdPanel.add(lEmail);
	lEmail.setBounds(30,20,200,27);
	tfEmail = new TextField(getEmail());
	sdPanel.add(tfEmail);
	tfEmail.setBounds(50, 50, 300, 27);
	
	lPop = new Label("Settings for receiving e-mails:");
	sdPanel.add(lPop);
	lPop.setBounds(30, 100, 200, 27);
	
	lPopServer = new Label("POP server:");
	lPopServer.setAlignment(Label.RIGHT);
	sdPanel.add(lPopServer);
	lPopServer.setBounds(50, 130, 100, 27);
	

	lPopUsername = new Label("POP username:");
	lPopUsername.setAlignment(Label.RIGHT);
	sdPanel.add(lPopUsername);
	lPopUsername.setBounds(50, 160, 100, 27);
	
	lPopPassword = new Label("POP password:");
	lPopPassword.setAlignment(Label.RIGHT);
	sdPanel.add(lPopPassword);
	lPopPassword.setBounds(50, 190, 100, 27);

	
	tfPopServer = new TextField(getPopServer());
	sdPanel.add(tfPopServer);
	tfPopServer.setBounds(155, 130, 150, 27);

	tfPopUsername = new TextField(getPopUsername());
	sdPanel.add(tfPopUsername);
	tfPopUsername.setBounds(155, 160, 150, 27);

	tfPopPassword = new TextField(getPopPassword());
	sdPanel.add(tfPopPassword);
	tfPopPassword.setEchoChar('*');
	tfPopPassword.setBounds(155, 190, 150, 27);
	
	
	lSmtp = new Label("Settings for sending e-mails:");
	sdPanel.add(lSmtp);
	lSmtp.setBounds(30, 230, 200, 27);
	
	lSmtpServer = new Label("SMPT server:");
	lSmtpServer.setAlignment(Label.RIGHT);
	sdPanel.add(lSmtpServer);
	lSmtpServer.setBounds(50, 260, 100, 27);

	tfSmtpServer = new TextField(getSmtpServer());
	sdPanel.add(tfSmtpServer);
	tfSmtpServer.setBounds(155, 260, 150, 27);
	
	bOk = new Button("OK");
	sdPanel.add(bOk);
	bOk.addActionListener(this);
	bOk.setBounds( 310, 330, 60, 27);
	
	bCancel = new Button("Cancel");
	sdPanel.add(bCancel);
	bCancel.addActionListener(this);
	bCancel.setBounds( 240, 330, 60, 27);

	sdFrame.add(sdPanel);
	sdFrame.setVisible(true);
}
/**
 * This method was created in VisualAge.
 * @param s java.io.ObjectInputStream
 * @exception java.io.IOException The exception description.
 */
public void readData(SerializeDataEvent e) {
	ObjectInputStream in = e.getObjectInputStream();
	try {
		setEmail((String)in.readObject());
		setPopServer((String)in.readObject());
		setPopUsername((String)in.readObject());
		setPopPassword((String)in.readObject());
		setSmtpServer((String)in.readObject());
	} catch (IOException ex) {
		System.out.println("IOException in mailbean.SettingsDialog.readProperties(): "+ex.getMessage());
	} catch (ClassNotFoundException ex) {
		System.out.println("ClassNotFoundException in mailbean.SettingsDialog.readProperties(): "+ex.getMessage());
	}
}
/**
 * This method was created in VisualAge.
 * @param s java.io.ObjectInputStream
 * @exception java.io.IOException The exception description.
 */
private void readObject(ObjectInputStream s) throws IOException {
	try {
		s.defaultReadObject();
		popServer = (String)s.readObject();
		popUsername = (String)s.readObject();
		popPassword = (String)s.readObject();
		smtpServer = (String)s.readObject();
	} catch (ClassNotFoundException ex) {
		throw new IOException(ex.getMessage());
	}
}
/**
 * This method was created in VisualAge.
 * @param l java.beans.PropertyChangeListener
 */
public void removePropertyChangeListener(PropertyChangeListener l) {
	changes.removePropertyChangeListener(l);
}
/**
 * This method was created in VisualAge.
 * @param s java.lang.String
 */
public void setEmail(String s) {
	String old = email;
	email = s;
	changes.firePropertyChange("string", old, email);	
}
/**
 * This method was created in VisualAge.
 * @param s java.lang.String
 */
public void setPopPassword(String s) {
	String old = popPassword;
	popPassword = s;
	changes.firePropertyChange("string", old, popPassword);	
}
/**
 * This method was created in VisualAge.
 * @param s java.lang.String
 */
public void setPopServer(String s) {
	String old = popServer;
	popServer = s;
	changes.firePropertyChange("string", old, popServer);
}
/**
 * This method was created in VisualAge.
 * @param s java.lang.String
 */
public void setPopUsername(String s) {
	String old = popUsername;
	popUsername = s;
	changes.firePropertyChange("string", old, popUsername);
}
/**
 * This method was created in VisualAge.
 * @param s java.lang.String
 */
public void setSmtpServer(String s) {
	String old = smtpServer;
	smtpServer = s;
	changes.firePropertyChange("string", old, smtpServer);
}
/**
 * windowActivated method comment.
 */
public void windowActivated(java.awt.event.WindowEvent e) {
}
/**
 * windowClosed method comment.
 */
public void windowClosed(java.awt.event.WindowEvent e) {
}
/**
 * windowClosing method comment.
 */
public void windowClosing(java.awt.event.WindowEvent e) {
	sdFrame.dispose();
}
/**
 * windowDeactivated method comment.
 */
public void windowDeactivated(java.awt.event.WindowEvent e) {
}
/**
 * windowDeiconified method comment.
 */
public void windowDeiconified(java.awt.event.WindowEvent e) {
}
/**
 * windowIconified method comment.
 */
public void windowIconified(java.awt.event.WindowEvent e) {
}
/**
 * windowOpened method comment.
 */
public void windowOpened(java.awt.event.WindowEvent e) {
}
/**
 * This method was created in VisualAge.
 * @param s java.io.ObjectOutputStream
 * @exception java.io.IOException The exception description.
 */
public void writeData(SerializeDataEvent e) {
	ObjectOutputStream out = e.getObjectOutputStream();
	try {
		out.writeObject(email);
		out.writeObject(popServer);
		out.writeObject(popUsername);
		out.writeObject(popPassword);
		out.writeObject(smtpServer);
	} catch (IOException ex) {
		System.out.println("IOException mailbeans.SettingsDialog.writeProperties(): "+ex.getMessage());
	}
}
/**
 * This method was created in VisualAge.
 * @param s java.io.ObjectOutputStream
 * @exception java.io.IOException The exception description.
 */
private void writeObject(ObjectOutputStream s) throws IOException {
	s.defaultWriteObject();
	s.writeObject(popServer);
	s.writeObject(popUsername);
	s.writeObject(popPassword);
	s.writeObject(smtpServer);
}
}