package mailbeans;

import java.awt.*;
import java.awt.event.*;
import java.util.*;
/**
 * This type was created in VisualAge.
 */
public class SimpleMessageComposer extends Panel {
	private TextArea taMessage;
	private Label lTo;
	private Label lSubject;
	private Label lFrom;
	private TextField tfTo;
	private TextField tfSubject;
	private TextField tfFrom;
	Vector messageListener = new Vector();
	Vector outputListener = new Vector();
public SimpleMessageComposer() {
	super();
	setLayout(null);
	lTo = new Label("To: ");
	lTo.setAlignment(Label.RIGHT);
	add(lTo);
	tfTo = new TextField();
	add(tfTo);

	lSubject = new Label("Subject: ");
	lSubject.setAlignment(Label.RIGHT);
	add(lSubject);
	tfSubject = new TextField();
	add(tfSubject);

	lFrom = new Label("From: ");
	lFrom.setAlignment(Label.RIGHT);
	add(lFrom);
	tfFrom = new TextField();
	add(tfFrom);

	taMessage = new TextArea();
	add(taMessage);
}
/**
 * This method was created in VisualAge.
 * @param l ActionListener
 */
public void addMessageListener(MessageListener l) {
	messageListener.addElement(l);
}
/**
 * This method was created in VisualAge.
 * @param l MailBeans.OutputListener
 */
public void addOutputListener(OutputListener l) {
	outputListener.addElement(l);
}
/**
 * This method was created in VisualAge.
 */
public void doLayout() {
	lTo.setBounds(5, 5, 70, 27);
	tfTo.setBounds(80, 5, 250, 27);
	lSubject.setBounds(5, 35, 70, 27);
	tfSubject.setBounds(80, 35, 250, 27);
	lFrom.setBounds(5, 65, 70, 27);
	tfFrom.setBounds(80, 65, 250, 27);
	taMessage.setBounds(0, 110, getSize().width, getSize().height-110);
}
/**
 * This method was created in VisualAge.
 * @return java.awt.Dimension
 */
public Dimension getMinimumSize() {
	return new Dimension(300,300);
}
/**
 * This method was created in VisualAge.
 * @return java.awt.Dimension
 */
public Dimension GetPreferredSize() {
	return new Dimension(300,300);
}
/**
 * This method was created in VisualAge.
 * @param l java.awt.event.ActionListener
 */
public void removeMessageListener(MessageListener l) {
	messageListener.removeElement(l);
}
/**
 * This method was created in VisualAge.
 * @param l MailBeans.OutputListener
 */
public void removeOutputListener(OutputListener l) {
	outputListener.removeElement(l);
}
/**
 * This method was created in VisualAge.
 * @param e java.awt.event.ActionEvent
 */
public void send() {
	Message msg = new Message();
	msg.setTo(tfTo.getText());
	msg.setSubject(tfSubject.getText());
	msg.setFrom(tfFrom.getText());
	msg.setReturnPath(tfFrom.getText());
	msg.setMsgBody(taMessage.getText());
	
	
	msg.create(); // very important
	
	// Send Mail
	MessageEvent me = new MessageEvent(this, msg);
	for (int i=0; i<messageListener.size(); i++) {
		MessageListener ml = (MessageListener) messageListener.elementAt(i);
		ml.handleMessage(me);
	}
	tfSubject.setText("");
	tfTo.setText("");
	tfFrom.setText("");
	taMessage.setText("");
}
}