package mailbeans.mimetypes;

import java.util.*;
import java.awt.*;
import java.awt.event.*;
import mailbeans.*;
/**
 * This type was created in VisualAge.
 */
public class MimeTypeMultipart extends MimeConcreteType {
	String boundary;
	Vector parts;
	MimeTypes mimeTypes;
/**
 * MimeTypeMultipart constructor comment.
 */
public MimeTypeMultipart() {
	super();
}
/**
 * This method was created in VisualAge.
 * @param msg Sting
 */
public MimeTypeMultipart(String[] msg, MimeTypes mimeTypes) {
	init();
	this.mimeTypes = mimeTypes;
	this.msg = msg;
	parse();
}
/**
 * This method was created in VisualAge.
 * @param mimeTypes MailBean.MimeTypes
 */
public void addMimeTypes(MimeTypes mimeTypes) {
	this.mimeTypes = mimeTypes;
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public String getBoundary() {
	if (boundary=="") {
		String str = getParameter();
		if (str.toLowerCase().startsWith("boundary=")) {
			if (str.charAt(9)=='"') {
				boundary = "--"+str.substring(10, str.length()-1);
			} else {
				boundary = "--"+str.substring(9);
			}
		}
	}
	return boundary;
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public String getMimeType() {
	return "multipart";
}
/**
 * This method was created in VisualAge.
 */
public void init() {
	super.init();
	boundary = "";
	parts = new Vector();
	mimeTypes = null;
}
/**
 * This method was created in VisualAge.
 */
public void parse() {
	if (mimeTypes!=null) {
		int start = 0;
		for (int i=0; i<msg.length; i++) {
			if (msg[i].compareTo(getBoundary())==0) {
				if (start!=0) {
					String[] str = new String[i-start];
					for (int m=i; m>start; m--) {
						str[m-start-1] = msg[m-1];
					}
					// Create new MimeType
					MimeConcreteType mct = mimeTypes.getMimeConcreteType(str);
					if (mct!=null) {
						parts.addElement(mct);
					}
					start = i;
				} else {
					start = i;
				}
			}
			if (msg[i].compareTo(getBoundary()+"--")==0) {
				if (start!=0) {
					String[] str = new String[i-start];
					for (int m=i; m>start; m--) {
						str[m-start-1] = msg[m-1];
					}
					MimeConcreteType mct = mimeTypes.getMimeConcreteType(str);
					if (mct!=null) {
						parts.addElement(mct);
					}
					start = i;
				} else {
					start = i;
				}
			}
		}
	}
}
/**
 * This method was created in VisualAge.
 * @return mailbeans.MimeConcreteType
 * @param inx int
 */
public MimeConcreteType partAt(int inx) {
	return (MimeConcreteType)parts.elementAt(inx);
}
/**
 * This method was created in VisualAge.
 * @return java.util.Enumeration
 */
public Enumeration parts() {
	return parts.elements();
}
}