package mailbeans.viewers;

import java.awt.*;
import java.awt.event.*;
import mailbeans.*;
import mailbeans.mimetypes.*;
import java.io.*;
/**
 * This type was created in VisualAge.
 */
public class ViewerAttachment implements Viewer, ActionListener {
	MimeConcreteType mct;
	FileDialog fd;
/**
 * This method was created in VisualAge.
 * @param msg MailBean.Message
 */
public ViewerAttachment() {
}
/**
 * This method was created in VisualAge.
 * @param e java.awt.event.ActionEvent
 */
public void actionPerformed(ActionEvent e) {
	String cmd=e.getActionCommand();
	if (cmd.equals("Save")) {
		save();
	} 
}
/**
 * This method was created in VisualAge.
 * @return boolean
 * @param mct MimeConreteType
 */
public boolean fits() {
	return ((mct instanceof MimeTypeApplication)||(mct instanceof MimeTypeImageJPEG));
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public String getViewerName() {
	return "AttachmentViewer";
}
/**
 * This method was created in VisualAge.
 */
public void save() {
	fd = new FileDialog(new Frame(), "Save as...", FileDialog.SAVE);
	String filename = mct.getParameter();
	if (filename.toLowerCase().startsWith("name=")) {
		filename = filename.substring(5);
		if (filename.charAt(0)=='"') {
			filename = filename.substring(1,filename.length()-1);
		}
	} else filename = "";
	fd.setFile(filename);
	fd.show();
	filename = fd.getDirectory() + fd.getFile();
	if (filename!=null) {
		try {
			FileOutputStream fos = new FileOutputStream(filename);
			int i=0;
			while(mct.eof()) {
				String cte = mct.getContentTransferEncoding();
				if (mct!=null && cte.toLowerCase().equals("base64")) {
					int[] data = Base64.convert(mct.nextString());
					if (data!=null) {
						for (int j=0; j<data.length; j++) {
							fos.write(data[j]);
						}
					}
				} else {
					fos.write(mct.nextString().getBytes());
				}
			}
			fos.close();
		} catch (IOException ex) {
			System.out.println("IOException in mailbeans.viewers.actionPerformed: "+ex.getMessage());
		}
	}
}
/**
 * This method was created in VisualAge.
 */
public void setMimeConcreteType(MimeConcreteType mct) {
	this.mct = mct;
}
/**
 * This method was created in VisualAge.
 * @return java.awt.Panel
 * @param mct MailBeans.MimeConcreteType
 */
public Component view() {
	Panel p = new Panel();
	p.setLayout(null);
	Button b = new Button("Save");
	b.setBounds(10,10,100,27);
	
	b.addActionListener(this);
	p.add(b);
	return p;
}
}