package mailbeans.viewers;

import java.awt.*;
import java.awt.event.*;
import java.util.*;
import mailbeans.*;
import mailbeans.mimetypes.*;
/**
 * This type was created in VisualAge.
 */
public class ViewerMimeMultipart extends Panel implements Viewer, ComponentListener, ActionListener, ItemListener {
	MimeConcreteType mct;
	MimeViewers mimeViewers;
	Viewer currentViewer;
	Component mvComponent;
	Choice mvViewers;
	Label mvLViewers;
	List mvList;
/**
 * This method was created in VisualAge.
 * @param msg MailBean.Message
 */
public ViewerMimeMultipart() {
}
/**
 * This method was created in VisualAge.
 * @param mct mailbeans.MimeConcreteType
 * @param v mailbeans.Viewer
 */
public ViewerMimeMultipart(MimeViewers mv) {
	super();
	mimeViewers = mv;
}
/**
 * This method was created in VisualAge.
 * @param e java.awt.event.ActionEvent
 */
public void actionPerformed(ActionEvent e) {
	if (e!=null) {
		/*remove(mvComponent);
		MimeConcreteType m = ((MimeTypeMultipart)mct).partAt(getSelectedMessage());
		ViewerDefault vd = new ViewerDefault();
		vd.setMimeConcreteType(m);
		mvComponent=vd.view();
		add(mvComponent);
		resize();*/
		placeViewer();
		resize();
	}
}
/**
 * This method was created in VisualAge.
 * @param e java.awt.event.ComponentEvent
 */
public void componentHidden(ComponentEvent e) {
}
/**
 * This method was created in VisualAge.
 * @param e java.awt.event.ComponentEvent
 */
public void componentMoved(ComponentEvent e) {
}
/**
 * This method was created in VisualAge.
 * @param e java.awt.event.ComponentEvent
 */
public void componentResized(ComponentEvent e) {
	resize();
}
/**
 * This method was created in VisualAge.
 * @param e java.awt.event.ComponentEvent
 */
public void componentShown(ComponentEvent e) {
	resize();
}
/**
 * This method was created in VisualAge.
 * @return boolean
 * @param mct MimeConreteType
 */
public boolean fits() {
	return (mct instanceof MimeTypeMultipart);
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public String getViewerName() {
	return "MimeMultipartViewer";
}
/**
 * This method was created in VisualAge.
 * @param e java.awt.event.ItemEvent
 */
public void itemStateChanged(ItemEvent e) {
	boolean update = false;
	for (Enumeration en=mimeViewers.getViewers(((MimeTypeMultipart)mct).partAt(mvList.getSelectedIndex())).elements(); en.hasMoreElements();) {
		Viewer v = (Viewer)en.nextElement();
		mimeViewers.remove(v);
		if (e.getItem().equals(v.getViewerName())) {
			mimeViewers.select(v);
			update = true;
		}
	}
	if (update) {
		placeViewer();
		resize();				
	}
}
/**
 * This method was created in VisualAge.
 */
private void mvViewsChange() {
	mvViewers.removeAll();
	MimeConcreteType m = ((MimeTypeMultipart)mct).partAt(mvList.getSelectedIndex());
	
	
	for (Enumeration en=mimeViewers.getViewers(m).elements(); en.hasMoreElements();) {
		Viewer v = (Viewer)en.nextElement();
		mvViewers.add(v.getViewerName());
		/*if (mimeViewers.isSelected(v)) {
			mvViewers.select(v.getViewerName());
		}*/
	}
	mvViewers.select(currentViewer.getViewerName());
}
/**
 * This method was created in VisualAge.
 */
private void placeViewer() {
	if (mvComponent!=null) remove(mvComponent);
	mvComponent=null;
	//Viewer selectedViewer=null;
	int counter=0;
	for (Enumeration en=mimeViewers.getViewers(((MimeTypeMultipart)mct).partAt(mvList.getSelectedIndex())).elements(); en.hasMoreElements();) {
		Viewer v=(Viewer)en.nextElement();
		if (mimeViewers.isSelected(v)) {
			currentViewer=v;
			counter++;
		}
	}
	if (counter==1) {
		mvComponent=currentViewer.view(); //.view(mimeMsg.getMimeConcreteType());
	}
	else if (counter==0) {
	}
	if (mvComponent==null) {
		MimeConcreteType m = ((MimeTypeMultipart)mct).partAt(mvList.getSelectedIndex());
		currentViewer = new ViewerDefault();
		currentViewer.setMimeConcreteType(m);
		mvComponent=currentViewer.view();
	}
	add(mvComponent);
	mvViewsChange();
}
/**
 * This method was created in VisualAge.
 */
public void popupActionPerformed(String cmd) {
	boolean update = false;
	for (Enumeration en=mimeViewers.getViewers(((MimeTypeMultipart)mct).partAt(mvList.getSelectedIndex())).elements(); en.hasMoreElements();) {
		Viewer v = (Viewer)en.nextElement();
		mimeViewers.remove(v);
		if (cmd.equals(v.getViewerName())) {
			System.out.println(cmd);
			mimeViewers.select(v);
			update = true;
		}
	}
	if (update) {
		placeViewer();
		resize();				
	}
}
/**
 * This method was created in VisualAge.
 */
public void resize() {
	int w = getSize().width;
	int h = getSize().height;
	mvComponent.setBounds(0, 0, w, h-100);
	mvList.setBounds(0, h-95, 200, 90);
	mvLViewers.setBounds(210,h-95, 60, 27);
	mvViewers.setBounds(270,h-95, 150, 27);
}
/**
 * This method was created in VisualAge.
 */
public void setMimeConcreteType(MimeConcreteType mct) {
	this.mct = mct;
}
/**
 * This method was created in VisualAge.
 * @return java.awt.Panel
 * @param mct MailBeans.MimeConcreteType
 */
public Component view() {
	MimeTypeMultipart mtm;
	if (mct instanceof MimeTypeMultipart) {
		mtm=(MimeTypeMultipart)mct;
		setLayout(null);
		addComponentListener(this);
		mvComponent = new TextArea();
		add(mvComponent);
		mvList = new List();
		mvList.addActionListener(this);
		//mvPList.setPListListener(this);
		add(mvList);
		mvLViewers = new Label("Viewers:");
		add(mvLViewers);
		for (Enumeration en=mtm.parts(); en.hasMoreElements();) {
			MimeConcreteType m = (MimeConcreteType)en.nextElement();
			mvList.add(m.getMimeType()+"   "+m.getContentDescription());
		}
		mvList.select(0);
		mvViewers = new Choice();
		add(mvViewers);
		mvViewers.addItemListener(this);
		placeViewer();
	}
	return this;
}
}